// mpicc 7-allgather-2.c -Wall -o test.x

#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <time.h>
#include <math.h>

int main( int argc, char *argv[] )
{
   int i, n=2, *local_buffer=NULL, *rec_buffer=NULL;
   
   MPI_Init(&argc,&argv);
   int me, nProcs;
   MPI_Comm_rank( MPI_COMM_WORLD, &me );
   MPI_Comm_size( MPI_COMM_WORLD, &nProcs );

   local_buffer = (int *) malloc( n * sizeof(int) );
   srand48( (unsigned) me );
   for( i=0; i<n; i++ )
      local_buffer[i]=(int) floor(drand48()*100);
   printf( "(%d) local: [%d, %d]\n", me, local_buffer[0], local_buffer[1]);

   rec_buffer = (int *) malloc( n * nProcs * sizeof(int) );

   // Gather + Bcast

   MPI_Gather( local_buffer, n, MPI_INT,
               rec_buffer,   n, MPI_INT, nProcs-1, MPI_COMM_WORLD );
   
   MPI_Bcast( rec_buffer, n*nProcs, MPI_INT, nProcs-1, MPI_COMM_WORLD );
   
   for( i=0; i<nProcs*n; i++ )
         printf( "\t(%d) \t\tcollected[%d]=%d\n", me, i, rec_buffer[i]);
   
   MPI_Finalize();
   return 0;
}


